/* tslint:disable */
/* eslint-disable */

export class SimulationWasm {
  free(): void;
  [Symbol.dispose](): void;
  add_boid(): void;
  boid_buffer_len(): number;
  boid_buffer_ptr(): number;
  boid_buffer_stride(): number;
  get_align_mult(): number;
  get_boid_count(): number;
  get_cohesion_mult(): number;
  get_separation_mult(): number;
  constructor(width: number, height: number, num_boids: number);
  remove_boid(): void;
  resize(width: number, height: number): void;
  set_align_mult(value: number): void;
  set_cohesion_mult(value: number): void;
  set_separation_mult(value: number): void;
  step(): void;
}

export type InitInput =
  | RequestInfo
  | URL
  | Response
  | BufferSource
  | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly __wbg_simulationwasm_free: (a: number, b: number) => void;
  readonly simulationwasm_add_boid: (a: number) => void;
  readonly simulationwasm_boid_buffer_len: (a: number) => number;
  readonly simulationwasm_boid_buffer_ptr: (a: number) => number;
  readonly simulationwasm_boid_buffer_stride: (a: number) => number;
  readonly simulationwasm_get_align_mult: (a: number) => number;
  readonly simulationwasm_get_boid_count: (a: number) => number;
  readonly simulationwasm_get_cohesion_mult: (a: number) => number;
  readonly simulationwasm_get_separation_mult: (a: number) => number;
  readonly simulationwasm_new: (a: number, b: number, c: number) => number;
  readonly simulationwasm_remove_boid: (a: number) => void;
  readonly simulationwasm_resize: (a: number, b: number, c: number) => void;
  readonly simulationwasm_set_align_mult: (a: number, b: number) => void;
  readonly simulationwasm_set_cohesion_mult: (a: number, b: number) => void;
  readonly simulationwasm_set_separation_mult: (a: number, b: number) => void;
  readonly simulationwasm_step: (a: number) => void;
  readonly __wbindgen_export: (a: number) => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;

/**
 * Instantiates the given `module`, which can either be bytes or
 * a precompiled `WebAssembly.Module`.
 *
 * @param {{ module: SyncInitInput }} module - Passing `SyncInitInput` directly is deprecated.
 *
 * @returns {InitOutput}
 */
export function initSync(
  module: { module: SyncInitInput } | SyncInitInput
): InitOutput;

/**
 * If `module_or_path` is {RequestInfo} or {URL}, makes a request and
 * for everything else, calls `WebAssembly.instantiate` directly.
 *
 * @param {{ module_or_path: InitInput | Promise<InitInput> }} module_or_path - Passing `InitInput` directly is deprecated.
 *
 * @returns {Promise<InitOutput>}
 */
export default function __wbg_init(
  module_or_path?:
    | { module_or_path: InitInput | Promise<InitInput> }
    | InitInput
    | Promise<InitInput>
): Promise<InitOutput>;
